$IFUNC=1;

$GREP="grep";
$PS="ps";
$SU="su";
$WC="wc";
$HOSTNAME="hostname";
$DIRNAME="dirname";
$LS="ls";

sub getInstanceCount
{
        my $num;
        $num = 0;
        $num=`$PS -ef | $GREP ora_pmon | $GREP -v grep | $WC -l`;
        chomp($num);
        $num =~ s/^\s+//;
        $num =~ s/\s+$//;
        return $num;
}

sub getOracleHome
{
        my($pid) = @_;
        my($home, @tok);
        $procpath = "/proc/$pid/exe";
        $link = `$LS -l $procpath`;
        @procs = split(/->/, $link);
        $path = $procs[1];
        $path =~ s/^\s+//;
        $path =~ s/\s+$//;
        @tokhome = split(/\//, $path);
        $numtok = $#tokhome;
        # due to tokenizing on / first token is empty
        for($cnt = 0; $cnt <= $numtok - 2; ++$cnt)
        {
                $h = $tokhome[$cnt];
                if($h ne "")
                {
                        $home .= "/$h";
                }
        }
       return $home;
}

sub getInstanceDetails()
{
        my($instance);
        ($instance) = (@_);
        foreach $inst(@INSTANCES)
        {
                @tok=split(/\s+/, $inst);
                $sid=$tok[1];
                $owner=$tok[0];
                if($sid eq $instance)
                {
                        return "$sid $owner";
                }
        }
        return "ERROR";

}

sub runListenerScript
{
        my($owner, $lname, $home, $tnsadmin) = (@_);
	my($passwd);
	my $success = 0;
        undef(@DISCINFO);
	$passwd = getLsnrPwd($tnsadmin, $lname);
        open(INFO, "/opt/VRTSagents/ha/bin/Netlsnr/NetlsnrDiscovery.sh $home $lname $owner -t '$tnsadmin' -p '$passwd'|");
        while($line = <INFO>)
        {
                chomp($line);
                $line =~ s/^\s+//;
                if($line =~ /Services Summary/)
                {
			$success = 1;
                                last;
                }
        }
	if($success == 0)
	{
		return 1;
	}
        while($line = <INFO>)
        {
                        chomp($line);
                        $line =~ s/^\s+//;
                        if($line =~ /The command completed successfully/)
                        {
                        return 0;
                        }
                        elsif($line =~ /has .* service handler\(s\)/)
                        {
                                        @tok=split(/\s+/,$line);
                                        $tok[0] =~ s/\"//g;
                                        push(@DISCINFO, $tok[0]);
                        }
                        elsif($line =~ /has .* handler\(s\) for this service/)
                        {
                                        @tok=split(/\s+/,$line);
                                        $tok[1] =~ s/\"//g;
                                        $tok[1] =~ s/,$//;
                                        push(@DISCINFO, $tok[1]);
                        }
        }
	return 1;
}

sub getMounts()
{
        my($owner, $sid, $home, $version);
        ($owner, $sid, $home, $version) = (@_);
        my (@files);
        push(@files, "datafile");
	if($version =~ /^9/ || $version =~ /^10/)
        {
                push(@files, "tempfile");
        }
        push(@files, "controlfile");
        push(@files, "logfile");
        push(@files, "archivelog");
        undef(@MPNTS);
        foreach $file(@files)
        {
                open(MOUNTS, "$MOUNTSCRIPT $sid $home $owner $file|");
                while($line = <MOUNTS>)
                {
                        chomp($line);
                        if($line =~ /-------------------------/)
                        {
                                last;
                        }
                        elsif($line =~ /^ORA-/)
                        {
                                return $line;
                        }
                }
                while($line = <MOUNTS>)
                {
                        chomp($line);
                        if( $line =~ /rows selected/ )
                        {
                                last;
                        }
                        elsif($line =~ /row selected/)
                        {
                                last;
                        }
                        elsif($line =~ /Disconnected/)
                        {
                                last;
                        }
                        elsif($line ne "")
                        {
                                push(@MPNTS, $line);
                        }
                }
                close MOUNTS;
        }
        return "";
}

sub getInstanceVersion
{
        my($owner, $sid, $home);
        ($owner, $sid, $home) = (@_);
        open(MOUNTS, "$MOUNTSCRIPT $sid $home $owner version|");
        while($line = <MOUNTS>)
        {
                chomp($line);
                if($line =~ /-----------/)
                {
                        last;
                }
        }
        $version = <MOUNTS>;
        chomp($version);
        $version =~ s/^\s+//;
        @tok = split(/\s+/, $version);
        close MOUNTS;
        return $tok[0];
}

sub getSPfile
{
        my($owner, $sid, $home);
        ($owner, $sid, $home) = (@_);
        open(SPFILE, "$MOUNTSCRIPT $sid $home $owner spfile|");
        while($line = <SPFILE>)
        {
                chomp($line);
                if($line =~ /-----------------/)
                {
                        last;
                }
        }
        $spfile = <SPFILE>;
        if($spfile =~ /Disconnected/)
        {
                return "";
        }
        chomp($spfile);
        $spfile =~ s/^\s+//;
        @tok = split(/\s+/, $spfile);
        close SPFILE;
        return $tok[0];
}

sub getListenerIP
{
        my $filename = shift;
        my $lsnrname = shift;
        my @ADDRESSES;
        my $start = 0;
        my $count = 0;
        $lsnrname = "$lsnrname=";
        open(CONF, $filename);
        while($line = <CONF>)
        {
                chomp($line);
                $line =~ s/\s+//g;
		if ($line =~ /^#/)
		{
			next;
		}
                if($line =~ /^$lsnrname/i && $start == 0)
                {
                        $start = 1;
                        $count = $count + getOpenCnt($line) - getCloseCnt($line);
                        next;
                }
                elsif($line =~ /\(HOST=/i && $start == 1)
                {
                        $addrline = $line;
                        @tok = split(/HOST=/, $addrline);
                        $address = $tok[1];
                        @addr = split(/\)/, $address);
                        $laddr = $addr[0];
                        $laddr =~ s/\s+//g;
                        if($laddr eq "")
                        {
                                $laddr = $hostname;
                        }
                        $laddr =~ s/^\"//;
                        $laddr =~ s/\"$//;
                        $laddr =~ s/^'//;
                        $laddr =~ s/'$//;
                        push(@ADDRESSES, $laddr);
                }
                if($start == 1)
                {
                        $count = $count + getOpenCnt($line) - getCloseCnt($line);
                        if( $count == 0)
                        {
                                last;
                        }
                }
        }
        return @ADDRESSES;
}

sub getOpenCnt
{
        $_ = shift;
        my $cnt = 0;
        while(/\(/g)
        {
                $cnt++;
        }
        return $cnt;
}

sub getCloseCnt
{
        $_ = shift;
        my $cnt = 0;
        while(/\)/g)
        {
                $cnt++;
        }
        return $cnt;
}

sub getListenerCount
{
        my $num;
        $num = 0;
        $num = `$PS -eo user,args | $GREP tnslsnr | $GREP -v grep | $WC -l`;
        chomp($num);
        $num =~ s/^\s+//;
        $num =~ s/\s+$//;
        return $num;
}

# Checks the oracle version
# Checks if database is parallel
# Discovers all paralle instances in the database
sub getDatabaseDetails()
{
        my($owner, $instance, $home, $hostname) = @_;
        # Get instance Version
        $version = getInstanceVersion($owner, $instance, $home);
        # We support only Oracle 9i/10g/11g RAC
        if($version !~ /^9/ && $version !~ /^10/ && $version !~ /^11/)
        {
                return "FALSE";
        }
        # Check whether database is parallel
        $isParallel = isDatabaseParallel($owner, $instance, $home);
        if($isParallel eq "FALSE")
        {
                return "FALSE";
        }
        # Get the database name
        $dbname = getDBName($owner, $instance, $home);
	$ret = isDBMounted($owner, $instance, $home);
        if($ret eq "0") #fatal
        {
		
        	return "$dbname\nERROR:NOTMOUNTED";
        }
	else
	{
        	# Get peer parallel OPS instances
        	$instances = getAllInstances($owner, $instance, $home);
		if($version =~ /^10/ || $version =~ /^11/)
		{
			$crs_ip = discover_crs_ip($home, $hostname);
        		return "$dbname $instances 10g $crs_ip";
		}
		else
		{
        		return "$dbname $instances";
		}
	}
}

#Checks if database is parallel
sub isDatabaseParallel()
{
        my($owner, $instance, $home) = @_;
        open(MOUNTS, "$MOUNTSCRIPT $instance $home $owner parallel|");
        while($line = <MOUNTS>)
        {
                chomp($line);
                if($line =~ /-----------------/)
                {
                        last;
                }
        }
        $isParallel = <MOUNTS>;
        chomp($isParallel);
        $isParallel =~ s/^\s+//;
        @tok = split(/\s+/, $isParallel);
        close MOUNTS;
        return $tok[0];
}

#Returns database name for the instance
sub getDBName()
{
        my($owner, $instance, $home) = @_;
        open(MOUNTS, "$MOUNTSCRIPT $instance $home $owner dbname|");
        while($line = <MOUNTS>)
        {
                chomp($line);
                if($line =~ /--------/)
                {
                        last;
                }
        }
        $dbname = <MOUNTS>;
        chomp($dbname);
        $dbname =~ s/^\s+//;
        @tok = split(/\s+/, $dbname);
        close MOUNTS;
        return $tok[0];
}

# Discovers all instances in a parallel database
sub getAllInstances()
{
        my($owner, $instance, $home) = @_;
        my($toret);
        open(MOUNTS, "$MOUNTSCRIPT $instance $home $owner racinstances|");
        while($line = <MOUNTS>)
        {
                chomp($line);
                if($line =~ /--------/)
                {
                        last;
                }
        }
        while($line = <MOUNTS>)
        {
                chomp($line);
                if($line =~ /Disconnected/)
                {
                        last;
                }
                elsif( $line =~ /rows selected/ )
                {
                        last;
                }
                elsif($line =~ /row selected/)
                {
                        last;
                }
                elsif($line ne "")
                {
                        $instance = $line;
                        $instance =~ s/^\s+//;
                        $toret .= "$instance ";
                }
        }
        close MOUNTS;
        $toret =~ s/\s+$//;
        return $toret;
}

sub getInstances()
{
        my($line, @tok, @sid, @INSTANCES);
        open(ORA,"$PS -ef | $GREP ora_pmon | $GREP -v grep |");
        while($line = <ORA>)
        {
                chomp($line);
                $line =~ s/^\s+//;
                @tok=split(/\s+/, $line);
                $num = $#tok;
                @sid=split(/_+/,$tok[$num]);
                push(@INSTANCES, "$tok[0] $sid[2]");
        }
        return @INSTANCES;
}

sub getListeners()
{
        my($line, @tok, $h, @LISTENERS, $HOME, $cnt, $numtok, $total, @tokhome, $lname);
        open(LIST,"$PS -eo user,pid,args | $GREP tnslsnr | $GREP -v grep |");
        while($line = <LIST>)
        {
                $HOME="";
                chomp($line);
                $line =~ s/^\s+//;
                @tok=split(/\s+/, $line);
                $total=$#tok;
                $owner=$tok[0];
		$pid=$tok[1];
                $home=$tok[$total-2];
		$user=getUserName($pid);
                @tokhome = split(/\//, $home);
                $numtok = $#tokhome;
                # due to tokenizing on / first token is empty
                for($cnt = 0; $cnt <= $numtok - 2; ++$cnt)
                {
                        $h = $tokhome[$cnt];
                        if($h ne "")
                        {
                                 $HOME .= "/$h";
                        }
                }

                $lname=$tok[$total-1];
                push(@LISTENERS, "$user $HOME $lname");
        }
        return @LISTENERS;
}

sub getLsnrsWithNonDefTnsAdmin()
{
	my(@listeners, $toret);
	@listeners = getListeners();
	foreach $line(@listeners)
	{
		($owner, $home, $lsnr) = split(/\s+/, $line, 3);
		$ret = checkTnsAdmin($owner, $lsnr, $home);
		if($ret eq 1)
		{
			$toret = $toret . $lsnr  . "\n";
		}
	}
	return $toret;
}

sub checkTnsAdmin
{
	my($owner, $lname, $home) = (@_);
	my($tnsadmin);
	$tnsadmin = "";
        system("/opt/VRTSagents/ha/bin/Netlsnr/NetlsnrDiscovery.sh $home $lname $owner $tnsadmin > /dev/null > /dev/null");
        if($? ne 0)
        {
		return 1;
	}
	return 0;
}	

sub isDatabaseSuspended
{
        my($owner, $sid, $home);
        ($owner, $sid, $home) = (@_);
        open(STATUS, "$MOUNTSCRIPT $sid $home $owner suspended|");
        while($line = <STATUS>)
        {
                chomp($line);
                if($line =~ /------/)
                {
                        last;
                }
        }
        $mode = <STATUS>;
        if($mode =~ /Disconnected/)
        {
                return "FALSE";
        }
        chomp($mode);
        $mode =~ s/^\s+//;
        $mode =~ s/\s+$//;
        close STATUS;
	if($mode =~ /SUSPENDED/)
        {
		return "TRUE"
       	}
	return "FALSE";
}

sub isDBMounted
{
        my($owner, $sid, $home);
        ($owner, $sid, $home) = (@_);
        open(STATUS, "$MOUNTSCRIPT $sid $home $owner status|");
        while($line = <STATUS>)
        {
                chomp($line);
                if($line =~ /------/)
                {
                        last;
                }
		if($line eq "")
		{
			next;
		}
        }
        $mode = <STATUS>;
        if($mode =~ /Disconnected/)
        {
                return "0";
        }
        chomp($mode);
        $mode =~ s/^\s+//;
        $mode =~ s/\s+$//;
        close STATUS;
	if($mode =~ /MOUNTED/ || $mode =~ /OPEN/)
        {
		return "1"
       	}
	return "0";
}

sub getLsnrPwd
{
        my($tnsadmin, $lsnrname) = (@_);
        my($lsnrfile, $matchstr, $passwd);
        $passwd = "";
        $lsnrfile = "$tnsadmin/listener.ora";
        $matchstr = "PASSWORDS_$lsnrname=";
        open(LSNRFILE, $lsnrfile);
        while($line = <LSNRFILE>)
        {
                chomp($line);
                $line =~ s/\s+//g;
                if($line =~ /^$matchstr/i)
                {
                        $line =~ s/^$matchstr//i;
                        $passwd = $line;
                        last;
                }
        }
        if($passwd eq "")
        {
                return "";
        }
        @tok = split(/,/, $passwd);
        $passwd = $tok[0];
        $passwd =~ s/^\(//;
        $passwd =~ s/\)$//;
        return $passwd;
}

sub getUserName
{
	my($pid) = @_;
	my $uname;
	$uname = `$PS -o user $pid | $GREP -v USER`;
	chomp($uname);
	return $uname;
}

sub discover_lltlinks()
{
	my $llttab = "/etc/llttab";
	my @macaddrs;
	die if(open(LLTTAB, $llttab) == 0);
	while($line = <LLTTAB>)
	{
		chomp($line);
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if($line =~ /^link/)
		{
			@tok = split(/\s+/, $line);
			$macaddr = $tok[2];
			if($macaddr =~ /^eth-/)
			{
				$macaddr =~ s/^eth-//;
				$result = `$IFCONFIG | $GREP -i $macaddr`;
				if($? == 0)
				{
					chomp($result);
					$result =~ s/^\s+//;
					$result =~ s/\s+$//;
					@parts = split(/\s+/, $result);
					print("$tok[1] $parts[0]\n");
				}
			}
			else
			{
				print("$tok[1] $tok[2]\n");
			}
		}	
	}
	close(LLTTAB);
}

sub discover_crs_home
{
	my $crsfile = "/etc/init.d/init.crsd";
	my $crs_home = "";
	die if(open(CRSFILE, $crsfile) == 0);
	while($line = <CRSFILE>)
	{
                chomp($line);
                $line =~ s/^\s+//;
                $line =~ s/\s+$//;
		next if($line =~ /^#/);		
		if($line =~ /^ORA_CRS_HOME/)
		{
			$line =~ s/ORA_CRS_HOME=//;
			$crs_home = $line;
			last;
		}
	}
	close(CRSFILE);
	return $crs_home;
}

sub discover_crs_ip
{
	my($orahome, $hostname) = @_;
	$ENV{'ORACLE_HOME'} = $orahome;
	my $crs_ip = "";
	$srvctl = "$orahome/bin/srvctl config nodeapps -n $hostname -a -g -s -l";
	die if(open(SRVCTL, "$srvctl |") == 0);
	while($line = <SRVCTL>)
	{
		chomp($line);
                $line =~ s/^\s+//;
                $line =~ s/\s+$//;
		if($line =~ /^VIP exists/)
		{
			@tok = split(/\//, $line);
			#print("$tok[2] $tok[3] $tok[4]\n");
			$crs_ip = $tok[2];
			last;
		}
	}
	close(SRVCTL);
	return $crs_ip;	
}
