# %W% %G% %U% - %Q% #
# ident "@(#)VCS:%M% %I%"
#
#  $Copyright: Copyright (c) 2010 Symantec Corporation.
#  All rights reserved.
#
#  THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#  SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#  WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#  The Licensed Software and Documentation are deemed to be commercial
#  computer software as defined in FAR 12.212 and subject to restricted
#  rights as defined in FAR Section 52.227-19 "Commercial Computer
#  Software - Restricted Rights" and DFARS 227.7202, "Rights in
#  Commercial Computer Software or Commercial Computer Software
#  Documentation", as applicable, and any successor regulations. Any use,
#  modification, reproduction release, performance, display or disclosure
#  of the Licensed Software and Documentation by the U.S. Government
#  shall be solely in accordance with the terms of this Agreement.  $

#!/bin/sh

if [ -x "/usr/bin/perl" ]; then
        PERL=/usr/bin/perl
elif [ -x "/opt/VRTSperl/bin/perl" ]; then
        PERL=/opt/VRTSperl/bin/perl
else
        PERL=`/usr/bin/which perl | /usr/bin/grep -v '^no'`
        if [ -z "$PERL" ]; then
                echo "Cannot find a version of perl to execute script"
                exit 1
        fi
fi
eval 'exec $PERL -x -S $0 ${1+"$@"}'
        if 0;
#!perl
$ORA_SID=$ARGV[0];
$ORA_HOME=$ARGV[1];
$OWNER=$ARGV[2];
$FILE=$ARGV[3];
if ( -d "$ORA_HOME/lib64" ) 
{
    $LIB="/usr/lib:$ORA_HOME/lib64:\\\$LD_LIBRARY_PATH";
} 
else 
{
    $LIB="/usr/lib:$ORA_HOME/lib:\\\$LD_LIBRARY_PATH";
}

$COLUMN="name";
$SU="/bin/su";

$ENV{'ORACLE_HOME'} = $ORA_HOME;
$ENV{'ORACLE_SID'} = $ORA_SID;
$ENV{'NLS_LANG'} = "American_America.US7ASCII";
$ENV{'NLS_LANGUAGE'} = "American_America.US7ASCII";
$ENV{'NLS_TERRITORY'} = "AMERICA";
$ENV{'LD_LIBRARY_PATH'} = $LIB;
undef $ENV{'BASH_ENV'};
undef $ENV{'TWO_TASK'};

if( -x "$ORA_HOME/bin/svrmgrl")
{
	$DBAMGR = "$ORA_HOME/bin/svrmgrl";
	$CONNECTSTR="connect internal";
	$SETSTR="set charwidth 500\n";
}
elsif( -x "$ORA_HOME/bin/sqlplus")
{
	$DBAMGR = "$ORA_HOME/bin/sqlplus /nolog";
	$CONNECTSTR="connect / as sysdba";
	$SETSTR="set pagesize 1000\nset linesize 500\n";
}

if( $FILE eq "logfile")
{
	$Query = "select member from v\\\$logfile";
}
elsif( $FILE eq "version")
{
	$Query = "select version from v\\\$instance";
}
elsif( $FILE eq "datafile" || $FILE eq "controlfile" || $FILE eq "tempfile")
{
	$Query = "select name from v\\\$$FILE";
}
elsif( $FILE eq "archivelog")
{
	$Query = "select destination from v\\\$archive_dest a,v\\\$parameter b where a.status ='VALID' and b.name ='log_archive_start' and b.value='TRUE'" ;
}
elsif( $FILE eq "parallel")
{
	$Query = "select value from v\\\$parameter where name='cluster_database'";
}
elsif( $FILE eq "dbname")
{
	$Query = "select value from v\\\$parameter where name='db_name'";
}
elsif( $FILE eq "racinstances")
{
	$Query = "select distinct instance from v\\\$thread";
}
elsif( $FILE eq "spfile")
{
	$Query = "select value from v\\\$parameter where name='spfile'";
}
elsif( $FILE eq "status")
{
	$Query = "select status from v\\\$instance";
}
elsif( $FILE eq "suspended")
{
	$Query = "select database_status from v\\\$instance";
}
$SQLResult = `$SU $OWNER -c "$DBAMGR" <<!
$CONNECTSTR;
$SETSTR;
$Query;
exit
!`;

@lines = split(/\n+/, $SQLResult);
foreach $line(@lines)
{
	$line =~ s/\s+$//;
	print("$line\n");
}
