eval 'exec /opt/VRTSperl/bin/perl -I $CLUSTER_HOME/lib -Sw $0 ${1+"$@"}'
        if 0;
# %W% %G% %U% - %Q% #
#ident "@(#)VCSOR:%M% %I%"
#
# $Copyright: Copyright (c) 2010 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#
# This script checks the status of an Oracle instance. It monitors
# the instnace by updating a row in a table within a user defined schema.
#
# To debug this Perl script, use:
#     perl -d <this_script_name> <values_of_arguments_below_from_main.cf>
# Set DBG LEVEL to 21 to get the command line outputs in the log file.
# Some arguments to this script are unused. Do not remove. They help in
# keeping the arguments same and consistent across all the related scripts.
#

my ($ResName, $SID, $Owner, $Home,
        $PFile, $StartUpOpt, $ShutDownOpt, $EnvFile, $AutoEndBkup,
        $DetailMonitor, $User, $EncPword, $Table,$MonScript,
                        $AgentDebug, $Encoding, $MonitorOption) = @ARGV;

# Set the environment variables for agent logging using "halog"
use ag_i18n_inc;
$ResName = $ARGV[0]; shift;
VCSAG_SET_ENVS ($ResName);

#platform specific paths are set in the oraconfig.pm file
no lib ".";
use lib qw(.);
use oraconfig () ;
use vars qw(%CONF);
*CONF =\%oraconfig::CONF;
my $GREP = $CONF{GREP};
my $SU = $CONF{SU};
my $PASSWDGREP = $CONF{PASSWDGREP};

#### use oraclelib - functions #####
use oraclelib;
use strict;

my $use_csh = 0;
my ($ret,$DBAMGR,$CONNECTSTR,$out,$SQLResult,$SETSTR);

# 70 chars line to distinguish the Agent scripts/Oracle output from the 
# Engine output in the Engine log. - and = used instead of "begin"/"end"
# for NLS-compatibility.
#
my $BEGLINE="+-----------------------------------------------------------" .
							"---------+\n";
my $ENDLINE="+===========================================================" .
							"=========+";
$Home =~ s/^\s*(.*?)\s*$/$1/;
$Home =~ s/\/?$//;

my ($i,@lines);

if( `$PASSWDGREP $Owner` =~ m/(^|[\r\n])$Owner:[^\n\r]*\/bin\/[^\r\n]*csh([\r\n]|$)/ ) {
        $use_csh=1;
}

if ($AgentDebug == 1) {
	my $final_string = "";
	for (@ARGV) {
		 $final_string = $final_string . "\\\"" . $_ ."\\\" ";
	}
	VCSAG_LOGDBG_MSG(4,"ARGV is: $final_string");
}

#
# Bail if the Oracle home directory doesn't exist
#
$ret =oraclelib::check_oracle_home ($Home);
if ($ret) {
        VCSAG_LOG_MSG ("E","Oracle home directory $Home does not exist",1,$Home);
        exit $VCSAG_RES_OFFLINE;
}

#
# The Agent scripts use OS authentication. Therefore, the DBA has to 
# ensure the Oracle requirements for OS authentication to work fine.
# For e.g: the following parameter, if set, should be as follows in 
# the pfile:
#   "remote_login_passwordfile=none" (none is the default value)
#
# Further details: 
#   o Oracle 8i/9i Administrator's Guide
#   o Oracle 8i/9i SQL*Plus User's Guide and Reference
#

$ENV{'ORACLE_HOME'} = $Home;
$ENV{'ORACLE_SID'} = $SID;

#
# $TWO_TASK is used to specify a SQLNET or NET8 connect alias, which requires
# that the listener is already running and appropriately configured. However,
# by default, the listener is started after the Oracle server. Unset TWO_TASK,
# so that the bequeath adapter (BEQ) is used to spawn Oracle process.
# The BEQ adapter spawns the Oracle process and connects via Unix pipes.
#
undef $ENV{'TWO_TASK'} if defined $ENV{'TWO_TASK'};

#
my $LD_ENV = "";
my $ValidFile = 0;
$LD_ENV= oraclelib::set_environment($use_csh, $EnvFile, $Owner, $Home, $SID, $ValidFile);

if ( $ValidFile ) {
        VCSAG_LOG_MSG ( "W"," File $EnvFile is not a valid text file ",8,$EnvFile);
}

$ret =oraclelib::check_oracle_query_client ($Home, $DBAMGR, $CONNECTSTR, $LD_ENV);
if ($ret) {
        VCSAG_LOG_MSG ("E","sqlplus/svrmgrl not found in $Home/bin",2,$Home);
        exit $VCSAG_RES_UNKNOWN;
}

my $Pword="";
my $vcs_home=$VCSHOME;
$vcs_home = "/opt/VRTSvcs" if (!$vcs_home);

$EncPword =~s/^\s+//;
$EncPword =~s/\s+$//;

if ( $EncPword ) {
	$Pword = `$HADECRYPT $EncPword`;

	if ($? != 0) {
		VCSAG_LOG_MSG ( "W"," Encountered errors while decrypting password!",6);
		$Pword="";
	}
} else {
	VCSAG_LOG_MSG ( "W"," Empty password specified for detail monitoring",7);
}

############### Setup ends here ###########################################
# The following test updates a row "tstamp" with the latest value
# of the Oracle internal function SYSDATE
#
# A prerequisite for this test is that a user/password/table has been
# created before enabling the script by defining the attributes
# User/Pword/Table/MonScript for the Oracle resource.
#
# Note - In an OPS/RAC environment, create as many number of
# tables with unique names, as the number of instances to be deep monitored.
# These table names should be specified as local attributes in the main.cf
# configuration file per node.
#
# This task can be accomplished by the following SQL statements as DB-admin:
# (where SQL> is the SQL prompt from svrmgrl or sqlplus)
#
# svrmgrl
# [For 9i, as user oracle, run: sqlplus '/ as sysdba' instead of
#  (svrmgrl and 'connect internal')]
#
# SQL> connect internal
# SQL> create user <User>
#	  2> identified by <Pword>
#	  3> default tablespace USERS
#	  4> temporary tablespace TEMP
#	  5> quota 500K on USERS;
#
# USERS is the tablespacename present at all standard Oracle Installations.
# It might be replaced by any other tablespace for the specific installation.
# In an OPS/RAC environment, increase the quota for the USERS tablespace 
# proportionate to the tables being created.
#
# SQL> grant create session to <User>;
# SQL> create table <User>.<Table> ( tstamp date );
# SQL> insert into <User>.<Table> ( tstamp ) values ( SYSDATE );
#
# The name of the row "tstamp" should match the one of the update statement
# below!
#
# To test DB-setup use:
#
# SQL> disconnect
# SQL> connect <User>/<Pword>
# SQL> update <User>.<Table> set ( tstamp ) = SYSDATE;
# SQL> select TO_CHAR(tstamp, 'MON DD, YYYY HH:MI:SS AM')tstamp
#	  2> from <User>.<Table>;
# SQL> exit
#
# If you received the correct timestamp, the In-depth agent can be enabled

$SQLResult = `$SU $Owner -c "$LD_ENV; $DBAMGR" <<END1
connect ${User}/${Pword};
update ${User}.${Table} set ( tstamp ) = SYSDATE;
exit
END1`;

if ($? == 0 ) {

	@lines = split(/\n+/, $SQLResult);
	# row(s) processed: for svrmgrl
	# row(s) updated  : for sqlplus
	#
	for ($i=0; $i < @lines; $i++) {
		$_ = $lines[$i];
		if (/.*ORA-/) {
			VCSAG_LOGDBG_MSG(3,"Monitoring returned the output :$SQLResult ");
			$out= $SQLResult;
			print $out;
			exit $VCSAG_RES_OFFLINE;
		}
	}

	exit $VCSAG_RES_ONLINE;

} else  {

	exit $VCSAG_RES_OFFLINE;
}

